unit BigIma;

interface

uses Math,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons;

type
  TBigImaForm = class(TForm)
    Image1: TImage;
    Memo1: TMemo;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  BigImaForm: TBigImaForm;
  zoom : integer = 0;
  titre: string;

implementation

{$R *.DFM}

procedure TBigImaForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
if key=chr(27) then BigImaForm.Close;
if (key='+') and (zoom<3) then begin
   zoom:=zoom+1;
   image1.autosize:=false;
   image1.stretch:=true;
   image1.Width:=2*image1.Width;
   image1.Height:=2*image1.Height;
   HorzScrollBar.Position:=2*HorzScrollBar.Position;
   VertScrollBar.Position:=2*VertScrollBar.Position;
   BigImaForm.Caption:=Titre+'  Zoom x'+floattostr(Power(2,zoom));
end;
if (key='-') and (zoom>-3) then begin
   zoom:=zoom-1;
   image1.autosize:=false;
   image1.stretch:=true;
   image1.Width:=image1.Width div 2;
   image1.Height:=image1.Height div 2;
   HorzScrollBar.Position:=HorzScrollBar.Position div 2;
   VertScrollBar.Position:=VertScrollBar.Position div 2;
   BigImaForm.Caption:=Titre+'  Zoom x'+floattostr(Power(2,zoom));
end;
end;

procedure TBigImaForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   zoom:=0;  
   image1.autosize:=true;
   image1.stretch:=false;
end;

procedure TBigImaForm.FormShow(Sender: TObject);
begin
titre := Caption;
end;

end.
