unit CommentUnit;

interface

uses skylib,inifiles,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TCommentForm = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    BitBtn1: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    BitBtn2: TBitBtn;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Procedure SetLang;

var
  CommentForm: TCommentForm;

implementation

{$R *.DFM}

Procedure SetLang;
var section : string;
    inifile : Tinifile;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tinifile.create(AppDir+'\language'+language+'.ini');
section:='desc_'+language;
with CommentForm do
  with inifile do begin
    Caption:=ReadString(section,'title',deftxt);
    label1.Caption:=ReadString(section,'t_1',deftxt);
    label2.Caption:=ReadString(section,'t_2',deftxt);
    BitBtn1.Caption:=ReadString('buttons_'+language,'ok',deftxt);
    BitBtn2.Caption:=ReadString('buttons_'+language,'cancel',deftxt);
  end;
inifile.free;
end;
end;

procedure TCommentForm.FormCreate(Sender: TObject);
begin
setlang;
end;

end.
