unit HeureUnit;

interface

uses SkyLib,Inifiles,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls, Mask, EnhEdits;

Procedure SetLang;
Function GetTimeBias : double;

type
  THeure = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    CheckBox1: TCheckBox;
    Panel1: TPanel;
    CheckBox2: TCheckBox;
    Label7: TLabel;
    Label9: TLabel;
    nbj: TEdit;
    nbpas: TEdit;
    Label12: TLabel;
    UpDown1: TUpDown;
    SpeedButton1: TSpeedButton;
    RadioGroup1: TRadioGroup;
    CheckBox3: TCheckBox;
    Panel2: TPanel;
    Label1: TLabel;
    fuseau: TEdit;
    UpDown2: TUpDown;
    Panel3: TPanel;
    CheckBox4: TCheckBox;
    LongEdit1: TLongEdit;
    Label6: TLabel;
    Tdt_Ut: TLabel;
    Label8: TLabel;
    Panel4: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label13: TLabel;
    BitBtn4: TBitBtn;
    UpDown3: TUpDown;
    UpDown4: TUpDown;
    UpDown5: TUpDown;
    UpDown6: TUpDown;
    UpDown7: TUpDown;
    UpDown8: TUpDown;
    annee: TEdit;
    mois: TEdit;
    jours: TEdit;
    heure: TEdit;
    minute: TEdit;
    seconde: TEdit;
    BC: TRadioButton;
    AD: TRadioButton;
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure anneeChange(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure ADClick(Sender: TObject);
    procedure BCClick(Sender: TObject);
    procedure nbpasChange(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure LongEdit1Change(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Heure: THeure;
  CurrentY,CurrentM,CurrentD : integer;
  CurrentT,TimeB,DTUT : double;
  UseSysTime,TimerOn : boolean;
  SimNb,SimJ,SimH,SimM : Integer;
  lockAD_BC : boolean = false;

implementation

{$R *.DFM}

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='Time';
with Heure do
  with inifile do begin
    Caption:=ReadString('main','t_1',deftxt);
    CheckBox1.Caption:=ReadString(section,'t_1',deftxt);
    CheckBox2.Caption:=ReadString(section,'t_2',deftxt);
    Label1.Caption:=ReadString(section,'t_3',deftxt);
    Label8.Caption:=ReadString(section,'t_4',deftxt);
    Label5.Caption:=ReadString(section,'t_5',deftxt);
    Label2.Caption:=ReadString(section,'t_6',deftxt);
    BitBtn4.Caption:=ReadString(section,'t_7',deftxt);
    Label7.Caption:=ReadString(section,'t_8',deftxt);
    Label12.Caption:=ReadString(section,'t_9',deftxt);
    Label9.Caption:=ReadString(section,'t_10',deftxt);
    RadioGroup1.Items[0]:=ReadString(section,'t_11',deftxt);
    RadioGroup1.Items[1]:=ReadString(section,'t_12',deftxt);
    RadioGroup1.Items[2]:=ReadString(section,'t_13',deftxt);
    SpeedButton1.Caption:=ReadString(section,'t_14',deftxt);
    CheckBox3.Caption:=ReadString(section,'t_15',deftxt);
    CheckBox4.Caption:=ReadString(section,'t_16',deftxt);
    label6.Caption:=ReadString(section,'t_20',deftxt)+'  :';
    BitBtn1.Caption:=ReadString('buttons','ok',deftxt);
    BitBtn2.Caption:=ReadString('buttons','help',deftxt);
    BitBtn3.Caption:=ReadString('buttons','cancel',deftxt);
  end;
inifile.free;
end;
end;

Procedure MaskText;
begin
with Heure do begin
if UsesysTime then begin
   annee.Color:=clBtnFace ; annee.ReadOnly:=true;
   mois.Color:=clBtnFace ; mois.ReadOnly:=true;
   jours.Color:=clBtnFace ; jours.ReadOnly:=true;
   heure.Color:=clBtnFace ; heure.ReadOnly:=true;
   minute.Color:=clBtnFace ; minute.ReadOnly:=true;
   seconde.Color:=clBtnFace ; seconde.ReadOnly:=true;
   fuseau.Color:=clBtnFace ; fuseau.ReadOnly:=true;
   UpDown2.Enabled:=false;
   UpDown3.Enabled:=false;
   UpDown4.Enabled:=false;
   UpDown5.Enabled:=false;
   UpDown6.Enabled:=false;
   UpDown7.Enabled:=false;
   UpDown8.Enabled:=false;
   AD.Enabled:=false;
   BC.Enabled:=false;
   end
else begin
   annee.Color:=clWindow ; annee.ReadOnly:=false;
   mois.Color:=clWindow ; mois.ReadOnly:=false;
   jours.Color:=clWindow ; jours.ReadOnly:=false;
   heure.Color:=clWindow ; heure.ReadOnly:=false;
   minute.Color:=clWindow ; minute.ReadOnly:=false;
   seconde.Color:=clWindow ; seconde.ReadOnly:=false;
   fuseau.Color:=clWindow ; fuseau.ReadOnly:=false;
   CheckBox2.Checked:=false;
   UpDown2.Enabled:=true;
   UpDown3.Enabled:=true;
   UpDown4.Enabled:=true;
   UpDown5.Enabled:=true;
   UpDown6.Enabled:=true;
   UpDown7.Enabled:=true;
   UpDown8.Enabled:=true;
   AD.Enabled:=true;
   BC.Enabled:=true;
end;
if checkbox4.checked then begin
   Longedit1.Enabled:=true;
   LongEdit1.color:=clWindow;
end else begin
   Longedit1.Enabled:=false;
   LongEdit1.color:=clBtnFace;
end;
end;
end;

procedure THeure.FormShow(Sender: TObject);
var  m: string;
begin
CheckBox1.checked:=usesysTime;
CheckBox2.checked:=TimerOn;
//nbpas.text:=inttostr(SimNb);
updown1.Position:=simnb;
if SimJ<>0 then begin
   nbj.text:=inttostr(SimJ);
   RadioGroup1.ItemIndex:=0;
end;
if SimH<>0 then begin
   nbj.text:=inttostr(SimH);
   RadioGroup1.ItemIndex:=1;
end;
if SimM<>0 then begin
   nbj.text:=inttostr(SimM);
   RadioGroup1.ItemIndex:=2;
end;
fuseau.text:=floattostr(timeb);
if currenty>0 then begin
   annee.text:=inttostr(currenty);
   AD.checked:=true;
   BC.checked:=false;
end else begin
   annee.text:=inttostr(-currenty+1);
   AD.checked:=false;
   BC.checked:=true;
end;
mois.text:=inttostr(currentm);
jours.text:=inttostr(currentd);
str(DT_UT*3600:4:0,m);
Tdt_Ut.caption:=m;
m:=artostr(currentt);
heure.Text:=trim(copy(m,1,3));
minute.Text:=trim(copy(m,5,2));
seconde.Text:=trim(copy(m,8,2));
if not checkbox4.checked then Longedit1.Value:=round(DT_UT*3600);
MaskText;
end;

procedure THeure.BitBtn1Click(Sender: TObject);
begin
UseSysTime:=CheckBox1.Checked;
TimerOn:=CheckBox2.Checked;
TimeB:=strtoFloat(trim(fuseau.text));
if AD.checked then CurrentY:=strtoint(trim(annee.text))
              else CurrentY:=-strtoint(trim(annee.text))+1;
CurrentM:=strtoint(trim(mois.text));
CurrentD:=strtoint(trim(jours.text));
currentt:=strtoint(trim(heure.text))+strtoint(trim(minute.text))/60+strtoint(trim(seconde.text))/3600;
//SimNb:=strtoint(trim(nbpas.text));
simnb:=updown1.Position;
case RadioGroup1.ItemIndex of
 0 : begin
       SimJ:=strtoint(trim(nbj.text));
       SimH:=0;SimM:=0;
     end;
 1 : begin
       SimH:=strtoint(trim(nbj.text));
       SimJ:=0;SimM:=0;
     end;
 2 : begin
       SimM:=strtoint(trim(nbj.text));
       SimJ:=0;SimH:=0;
     end;
end;
modalresult:=mrOK;
end;

Function GetTimeBias : double;
var lt,st : TSystemTime;
begin
 GetLocalTime(lt);GetSystemTime(st);
 result:=round(24000000*(SystemTimeToDateTime(lt)-SystemTimeToDateTime(st)))/1000000;
end;

procedure THeure.CheckBox1Click(Sender: TObject);
begin
UseSysTime:=CheckBox1.checked;
if CheckBox1.checked then begin
 AD.checked:=true;
 BC.checked:=false; 
 annee.text:=Formatdatetime('yyyy',now);
 mois.text:=Formatdatetime('mm',now);
 jours.text:=Formatdatetime('dd',now);
 heure.text:=Formatdatetime('hh',now);
 minute.text:=Formatdatetime('nn',now);
 seconde.text:=Formatdatetime('ss',now);
 fuseau.text:=floattostr(gettimebias);
 Heure.Refresh;
end;
MaskText;
end;

procedure THeure.anneeChange(Sender: TObject);
var Y : integer;
    d : double;
    m : string;
begin
if trim(annee.text)>'' then begin
   Y:=strtointdef(trim(annee.text),1900);
   if BC.checked then begin
     Y:=-Y+1;
   end;
   lockAD_BC:=true;
   if Y > 0 then begin
     BC.checked:=false;
     AD.checked:=true;
     UpDown3.increment:=1;
     annee.text:=inttostr(abs(Y));
   end else begin
     AD.checked:=false;
     BC.checked:=true;
     UpDown3.increment:=-1;
     annee.text:=inttostr(abs(Y)+1);
   end;
   lockAD_BC:=false;
   if Y > 20000 then begin
          Y:=20000;
          annee.text:='20000';
          AD.checked:=true;
          BC.checked:=false;
   end;
   if Y < -20000 then begin
          Y:=-20000;
          annee.text:='20000';
          AD.checked:=false;
          BC.checked:=true;
   end;
   if checkbox4.checked then d:=Longedit1.Value/3600
                        else d:=DTminusUT(Y);
   str(d*3600:4:0,m);
   Tdt_Ut.caption:=m;
   if not checkbox4.checked then Longedit1.Value:=round(d*3600);
end;
end;

procedure THeure.SpeedButton1Click(Sender: TObject);
begin
//nbPas.text:='1';
updown1.Position:=1;
nbj.text:='1';
RadioGroup1.ItemIndex:=0;
end;

procedure THeure.BitBtn4Click(Sender: TObject);
begin
 AD.checked:=true;
 BC.checked:=false;
 annee.text:=Formatdatetime('yyyy',now);
 mois.text:=Formatdatetime('mm',now);
 jours.text:=Formatdatetime('dd',now);
 heure.text:=Formatdatetime('hh',now);
 minute.text:=Formatdatetime('nn',now);
 seconde.text:=Formatdatetime('ss',now);
 Heure.Refresh;
end;

procedure THeure.FormCreate(Sender: TObject);
begin
SetLang;
end;

procedure THeure.BitBtn2Click(Sender: TObject);
begin
showhelp('doc3.html#date');
end;

procedure THeure.ADClick(Sender: TObject);
begin
if lockAD_BC then exit;
BC.checked:=not AD.checked;
if AD.checked then UpDown3.increment:=1
              else UpDown3.increment:=-1;
anneeChange(Sender);
end;

procedure THeure.BCClick(Sender: TObject);
begin
if lockAD_BC then exit;
AD.checked:=not BC.checked;
if AD.checked then UpDown3.increment:=1
              else UpDown3.increment:=-1;
anneeChange(Sender);
end;

procedure THeure.nbpasChange(Sender: TObject);
var i,n : integer;
begin
val(nbpas.text,i,n);
if n=0 then begin
   updown1.position:=i;
   nbpas.text:=inttostr(updown1.position);
end else nbpas.text:=inttostr(updown1.position);
end;

procedure THeure.CheckBox4Click(Sender: TObject);
begin
MaskText;
anneeChange(Sender);
end;

procedure THeure.LongEdit1Change(Sender: TObject);
begin
anneeChange(Sender);
end;

end.
