unit LabelUnit;

interface

uses Skylib,Inifiles,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, Spin, ComCtrls;

Procedure SetLang;

type
  TLabelForm = class(TForm)
    RadioGroup1: TRadioGroup;
    GroupBox1: TGroupBox;
    Nom: TCheckBox;
    Mag: TCheckBox;
    Pos: TCheckBox;
    GroupBox2: TGroupBox;
    selection: TCheckBox;
    planetes: TCheckBox;
    variables: TCheckBox;
    doubles: TCheckBox;
    etoiles: TCheckBox;
    nebuleuses: TCheckBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Edit1: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    UpDown1: TUpDown;
    BitBtn3: TBitBtn;
    constabb: TCheckBox;
    constnom: TCheckBox;
    Panel1: TPanel;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    Shape7: TShape;
    Shape8: TShape;
    ColorDialog1: TColorDialog;
    s1: TEdit;
    s2: TEdit;
    s3: TEdit;
    s4: TEdit;
    s5: TEdit;
    s6: TEdit;
    s7: TEdit;
    s8: TEdit;
    sz1: TUpDown;
    sz2: TUpDown;
    sz3: TUpDown;
    sz4: TUpDown;
    sz5: TUpDown;
    sz6: TUpDown;
    sz7: TUpDown;
    sz8: TUpDown;
    occulaire: TCheckBox;
    Shape9: TShape;
    s9: TEdit;
    sz9: TUpDown;
    Edit2: TEdit;
    UpDown2: TUpDown;
    Edit3: TEdit;
    UpDown3: TUpDown;
    Edit4: TEdit;
    UpDown4: TUpDown;
    Edit5: TEdit;
    UpDown5: TUpDown;
    shortname: TCheckBox;
    Bevel1: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure Shape1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape3MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape4MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape5MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape6MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape7MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape8MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure s7Change(Sender: TObject);
    procedure s8Change(Sender: TObject);
    procedure Shape9MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure shortnameClick(Sender: TObject);
    procedure NomClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  LabelForm: TLabelForm;

implementation

{$R *.DFM}

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='label';
with LabelForm do
  with inifile do begin
    labelform.Caption:=ReadString(section,'t_1',deftxt);
    Label2.Caption:=ReadString(section,'t_2',deftxt);
    Label3.Caption:=ReadString(section,'t_3',deftxt);
    Radiogroup1.Caption:=ReadString(section,'t_4',deftxt);
    Radiogroup1.items[0]:=ReadString(section,'t_5',deftxt);
    Radiogroup1.items[1]:=ReadString(section,'t_6',deftxt);
    Groupbox1.Caption:=ReadString(section,'t_7',deftxt);
    Nom.Caption:=ReadString(section,'t_8',deftxt);
    Mag.Caption:=ReadString(section,'t_9',deftxt);
    Pos.Caption:=ReadString(section,'t_10',deftxt);
    Groupbox2.Caption:=ReadString(section,'t_11',deftxt);
    selection.Caption:=ReadString(section,'t_12',deftxt);
    planetes.Caption:=ReadString(section,'t_13',deftxt);
    variables.Caption:=ReadString(section,'t_14',deftxt);
    doubles.Caption:=ReadString(section,'t_15',deftxt);
    etoiles.Caption:=ReadString(section,'t_16',deftxt);
    nebuleuses.Caption:=ReadString(section,'t_17',deftxt);
    constabb.Caption:=ReadString(section,'t_18',deftxt);
    constnom.Caption:=ReadString(section,'t_19',deftxt);
    occulaire.Caption:=ReadString(section,'t_20',deftxt);
    shortname.Caption:=ReadString(section,'t_21',deftxt);
    BitBtn3.Caption:=ReadString('buttons','help',deftxt);
    BitBtn2.Caption:=ReadString('buttons','ok',deftxt);
    BitBtn1.Caption:=ReadString('buttons','cancel',deftxt);
  end;
inifile.free;
end;
end;

procedure TLabelForm.FormCreate(Sender: TObject);
begin
SetLang;
end;

procedure TLabelForm.BitBtn3Click(Sender: TObject);
begin
showhelp('doc3.html#label');
end;

procedure TLabelForm.Shape1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if ColorDialog1.Execute then Shape1.Brush.Color:=ColorDialog1.Color;
end;

procedure TLabelForm.Shape2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if ColorDialog1.Execute then Shape2.Brush.Color:=ColorDialog1.Color;
end;

procedure TLabelForm.Shape3MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if ColorDialog1.Execute then Shape3.Brush.Color:=ColorDialog1.Color;
end;

procedure TLabelForm.Shape4MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if ColorDialog1.Execute then Shape4.Brush.Color:=ColorDialog1.Color;
end;

procedure TLabelForm.Shape5MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if ColorDialog1.Execute then Shape5.Brush.Color:=ColorDialog1.Color;
end;

procedure TLabelForm.Shape6MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if ColorDialog1.Execute then Shape6.Brush.Color:=ColorDialog1.Color;
end;

procedure TLabelForm.Shape7MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if ColorDialog1.Execute then Shape7.Brush.Color:=ColorDialog1.Color;
Shape8.Brush.Color:=Shape7.Brush.Color;
end;

procedure TLabelForm.Shape8MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if ColorDialog1.Execute then Shape8.Brush.Color:=ColorDialog1.Color;
Shape7.Brush.Color:=Shape8.Brush.Color;
end;

procedure TLabelForm.s7Change(Sender: TObject);
begin
sz8.position:=sz7.position;
end;

procedure TLabelForm.s8Change(Sender: TObject);
begin
sz7.position:=sz8.position;
end;

procedure TLabelForm.Shape9MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if ColorDialog1.Execute then Shape9.Brush.Color:=ColorDialog1.Color;
end;

procedure TLabelForm.shortnameClick(Sender: TObject);
begin
if shortname.Checked then nom.Checked:=true;
end;

procedure TLabelForm.NomClick(Sender: TObject);
begin
if not nom.Checked then shortname.Checked:=false;
end;

end.
