unit LongIdent;

interface

uses SkyLib,Inifiles,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, RxRichEd;

Procedure SetLang;

type
  TLongIdentForm = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn2: TBitBtn;
    memo1: TRxRichEdit;
    BitBtn4: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure Memo1KeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  LongIdentForm: TLongIdentForm;

implementation

{$R *.DFM}

uses Sky_P1,ShowFile;

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='ident';
with LongIdentForm do
  with inifile do begin
    Caption:=ReadString(section,'title',deftxt);
    BitBtn2.Caption:=ReadString(section,'t_1',deftxt);
    BitBtn3.Caption:=ReadString(section,'t_2',deftxt);
    BitBtn1.Caption:=ReadString('buttons','close',deftxt);
    BitBtn4.Caption:=ReadString('main','t_22',deftxt);
  end;
inifile.free;
end;
end;

procedure TLongIdentForm.BitBtn1Click(Sender: TObject);
begin
   ModalResult := mrCancel;
   Close;
end;

procedure TLongIdentForm.Memo1KeyPress(Sender: TObject; var Key: Char);
begin
if key=chr(27) then  begin
   ModalResult := mrCancel;
   Close;
end;
end;

procedure TLongIdentForm.FormCreate(Sender: TObject);
begin
SetLang;
end;

procedure TLongIdentForm.FormShow(Sender: TObject);
begin
BitBtn1.setfocus;
end;

procedure TLongIdentForm.BitBtn2Click(Sender: TObject);
begin
close;
Sky_P1.Identification(IdentX,IdentY,1);
end;

procedure TLongIdentForm.BitBtn3Click(Sender: TObject);
begin
skylib.arcentre:=sky_p1.FindAR;
skylib.decentre:=sky_p1.FindDE;
if showfile.ShowFileForm.Visible then showfile.ShowFileForm.Close;
close;
sky_p1.NewPosition;
end;

procedure TLongIdentForm.BitBtn4Click(Sender: TObject);
begin
memo1.SelectAll;
memo1.CopyToClipboard;
end;

end.
