unit splashunit;

interface

uses IniFiles, Registry,Skylib,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, jpeg;

type
  Tsplash = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    Timer1: TTimer;
    Label2: TLabel;
    Label3: TLabel;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label4: TLabel;
    procedure Timer1Timer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  splash: Tsplash;
  SplashTimer: Boolean = true;

implementation

{$R *.DFM}

var lang : shortstring;

Procedure SetLang(lang : shortstring);
var section,buf : string;
    inifile : Tmeminifile;
const deftxt = '?';
begin
if lang>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='main';
buf:=inifile.ReadString(section,'title','Cartes du Ciel');
Splash.Label1.caption:=buf;
Splash.BitBtn2.Caption:=inifile.ReadString('buttons','cancel',deftxt);
Splash.BitBtn1.Caption:=inifile.ReadString('buttons','help',deftxt);
inifile.free;
end;
end;

procedure Tsplash.Timer1Timer(Sender: TObject);
begin
  Timer1.enabled:=false;
  splash.free;
end;

procedure Tsplash.FormShow(Sender: TObject);
begin
  if lang>'0' then Splashunit.SetLang(lang);
  if SplashTimer then Timer1.enabled:=true;
end;

procedure Tsplash.BitBtn1Click(Sender: TObject);
begin
showhelp('prgnotes.html');
end;

procedure Tsplash.FormCreate(Sender: TObject);
var ok: boolean;
    Registry1: TRegistry;
begin
Lang:='0';
Registry1 := TRegistry.Create;
with Registry1 do begin
  ok:=Openkey('Software\Astro_PC\Ciel\Config',false);
  if ok then begin
     if ValueExists('Language') then Lang:=ReadString('Language') ;
  end;
  CloseKey;
end;
Registry1.Free;
end;

end.
