unit FontsUnit;

interface

uses IniFiles,Skylib,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

Procedure SetLang;

type
  TFontsForm = class(TForm)
    FontDialog1: TFontDialog;
    Label2: TLabel;
    grillefont: TEdit;
    grillesize: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Label3: TLabel;
    grillegras: TCheckBox;
    Label4: TLabel;
    labelfont: TEdit;
    Labelsize: TEdit;
    BitBtn4: TBitBtn;
    labelgras: TCheckBox;
    Label5: TLabel;
    legendefont: TEdit;
    legendesize: TEdit;
    BitBtn5: TBitBtn;
    legendegras: TCheckBox;
    Label6: TLabel;
    statusfont: TEdit;
    statussize: TEdit;
    BitBtn6: TBitBtn;
    statusgras: TCheckBox;
    Label7: TLabel;
    listefont: TEdit;
    listesize: TEdit;
    BitBtn7: TBitBtn;
    listegras: TCheckBox;
    Label8: TLabel;
    impfont: TEdit;
    impsize: TEdit;
    BitBtn8: TBitBtn;
    impgras: TCheckBox;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    procedure Bittn1Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FontsForm: TFontsForm;

implementation

{$R *.DFM}

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='fonts';
with FontsForm do
  with inifile do begin
    Caption:=ReadString(section,'t_1',deftxt);
    Label2.Caption:=ReadString(section,'t_2',deftxt);
    Label3.Caption:=ReadString(section,'t_3',deftxt);
    Label4.Caption:=ReadString(section,'t_4',deftxt);
    Label5.Caption:=ReadString(section,'t_5',deftxt);
    Label6.Caption:=ReadString(section,'t_6',deftxt);
    Label7.Caption:=ReadString(section,'t_7',deftxt);
    Label8.Caption:=ReadString(section,'t_8',deftxt);
    Label9.Caption:=ReadString(section,'t_9',deftxt);
    Label10.Caption:=ReadString(section,'t_10',deftxt);
    Label11.Caption:=ReadString(section,'t_11',deftxt);
    BitBtn3.Caption:=ReadString('buttons','ok',deftxt);
    BitBtn2.Caption:=ReadString('buttons','cancel',deftxt);
  end;
inifile.free;
end;
end;

procedure TFontsForm.Bittn1Click(Sender: TObject);
begin
//FontDialog1.Options := [fdAnsiOnly];
FontDialog1.Options := [];
FontDialog1.Device:=fdScreen;
Fontdialog1.Font.Name:=grillefont.text;
Fontdialog1.Font.Size:=strtoint(grillesize.text);
if GrilleGras.Checked then Fontdialog1.Font.Style:=[fsBold]
                      else Fontdialog1.Font.Style:=[];
if Fontdialog1.Execute then begin
   grillefont.text:=Fontdialog1.Font.Name;
   grillesize.text:=inttostr(Fontdialog1.Font.Size);
   if Fontdialog1.Font.Style=[fsBold] then grillegras.checked:=true
                                      else grillegras.checked:=false;
end;
end;

procedure TFontsForm.BitBtn4Click(Sender: TObject);
begin
//FontDialog1.Options := [fdAnsiOnly];
FontDialog1.Options := [];
FontDialog1.Device:=fdScreen;
Fontdialog1.Font.Name:=labelfont.text;
Fontdialog1.Font.Size:=strtoint(labelsize.text);
if labelGras.Checked then Fontdialog1.Font.Style:=[fsBold]
                      else Fontdialog1.Font.Style:=[];
if Fontdialog1.Execute then begin
   labelfont.text:=Fontdialog1.Font.Name;
   labelsize.text:=inttostr(Fontdialog1.Font.Size);
   if Fontdialog1.Font.Style=[fsBold] then labelgras.checked:=true
                                      else labelgras.checked:=false;
end;
end;

procedure TFontsForm.BitBtn5Click(Sender: TObject);
begin
//FontDialog1.Options := [fdAnsiOnly];
FontDialog1.Options := [];
FontDialog1.Device:=fdScreen;
Fontdialog1.Font.Name:=legendefont.text;
Fontdialog1.Font.Size:=strtoint(legendesize.text);
if legendeGras.Checked then Fontdialog1.Font.Style:=[fsBold]
                      else Fontdialog1.Font.Style:=[];
if Fontdialog1.Execute then begin
   legendefont.text:=Fontdialog1.Font.Name;
   legendesize.text:=inttostr(Fontdialog1.Font.Size);
   if Fontdialog1.Font.Style=[fsBold] then legendegras.checked:=true
                                      else legendegras.checked:=false;
end;
end;

procedure TFontsForm.BitBtn6Click(Sender: TObject);
begin
//FontDialog1.Options := [fdAnsiOnly];
FontDialog1.Options := [];
FontDialog1.Device:=fdScreen;
Fontdialog1.Font.Name:=statusfont.text;
Fontdialog1.Font.Size:=strtoint(statussize.text);
if statusGras.Checked then Fontdialog1.Font.Style:=[fsBold]
                      else Fontdialog1.Font.Style:=[];
if Fontdialog1.Execute then begin
   statusfont.text:=Fontdialog1.Font.Name;
   statussize.text:=inttostr(Fontdialog1.Font.Size);
   if Fontdialog1.Font.Style=[fsBold] then statusgras.checked:=true
                                      else statusgras.checked:=false;
end;
end;

procedure TFontsForm.BitBtn7Click(Sender: TObject);
begin
//FontDialog1.Options := [fdAnsiOnly,fdFixedPitchOnly];
FontDialog1.Options := [];
FontDialog1.Device:=fdScreen;
Fontdialog1.Font.Name:=listefont.text;
Fontdialog1.Font.Size:=strtoint(listesize.text);
if listeGras.Checked then Fontdialog1.Font.Style:=[fsBold]
                      else Fontdialog1.Font.Style:=[];
if Fontdialog1.Execute then begin
   listefont.text:=Fontdialog1.Font.Name;
   listesize.text:=inttostr(Fontdialog1.Font.Size);
   if Fontdialog1.Font.Style=[fsBold] then listegras.checked:=true
                                      else listegras.checked:=false;
end;
end;

procedure TFontsForm.BitBtn8Click(Sender: TObject);
begin
//FontDialog1.Options := [fdAnsiOnly];
FontDialog1.Options := [];
FontDialog1.Device:=fdScreen;
Fontdialog1.Font.Name:=impfont.text;
Fontdialog1.Font.Size:=strtoint(impsize.text);
if impGras.Checked then Fontdialog1.Font.Style:=[fsBold]
                      else Fontdialog1.Font.Style:=[];
if Fontdialog1.Execute then begin
   impfont.text:=Fontdialog1.Font.Name;
   impsize.text:=inttostr(Fontdialog1.Font.Size);
   if Fontdialog1.Font.Style=[fsBold] then impgras.checked:=true
                                      else impgras.checked:=false;
end;
end;

procedure TFontsForm.FormCreate(Sender: TObject);
begin
SetLang;
end;

end.
