unit LangUnit;

interface

uses  IniFiles,Skylib,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TLangForm = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  LangForm: TLangForm;
  nblang : integer;
  Lang : shortstring;
//  LangLst : array[0..100] of shortstring;

implementation

{$R *.DFM}

Procedure SetLang;
var section : string;
    inifile : Tinifile;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tinifile.create(AppDir+'\language_'+language+'.ini');
section:='buttons';
with LangForm do
with inifile do begin
bitbtn1.caption:=ReadString(section,'ok',deftxt);
bitbtn2.caption:=ReadString(section,'cancel',deftxt);
end;
inifile.free;
end;
end;

Procedure SetLangTmp;
var section : string;
    inifile : Tmeminifile;
const deftxt = '?';
begin
if lang>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+lang+'.ini');
section:='buttons';
with LangForm do
with inifile do begin
bitbtn1.caption:=ReadString(section,'ok',deftxt);
bitbtn2.caption:=ReadString(section,'cancel',deftxt);
end;
inifile.free;
end;
end;

Function GetLangCode(buf:string):string;
var p : integer;
begin
p:=pos(' ',buf);
result:=trim(copy(buf,1,p-1));
end;

procedure TLangForm.FormCreate(Sender: TObject);
var inifile : Tinifile;
    i,j,p : integer;
    buf,code : string;
    fs : TSearchRec;
begin
i:=findfirst(appdir+'\'+'language_*.ini',0,fs);
while i=0 do begin
  inifile:=Tinifile.create(appdir+'\'+fs.name);
  buf:=inifile.ReadString('main','language','Invalid File '+fs.name);
  inifile.free;
  code:=extractfilename(fs.name);
  p:=pos('.',code);
  if p=0 then p:=9999;
  code:=copy(code,10,p-10);
  buf:=code+' '+buf;
  j:=ListBox1.Items.Add(buf);
//  langlst[j]:=buf;
  i:=findnext(fs);
end;
findclose(fs);
for j:=0 to Listbox1.Items.Count-1 do if GetLangCode(Listbox1.Items[j])=language then Listbox1.ItemIndex:=j;
LangUnit.Setlang;
end;

procedure TLangForm.FormShow(Sender: TObject);
var j : integer;
begin
if lang='0' then lang:='Fr';
for j:=0 to Listbox1.Items.Count-1 do if GetLangCode(Listbox1.Items[j])=lang then Listbox1.ItemIndex:=j;
end;

procedure TLangForm.ListBox1Click(Sender: TObject);
begin
Lang:=GetLangCode(Listbox1.Items[Listbox1.itemindex]);
SetLangTmp;
end;

end.
