unit ProjUnit;

interface

uses Skylib,Inifiles,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

Procedure SetLang;

type
  TProjForm = class(TForm)
    ComboBox2: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    ComboBox1: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ProjForm: TProjForm;

implementation

{$R *.DFM}

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='Projection';
with ProjForm do
  with inifile do begin
    Label1.Caption:=ReadString(section,'t_1',deftxt);
    Label2.Caption:=ReadString(section,'t_2',deftxt);
    Caption:=ReadString(section,'t_3',deftxt);
    RadioGroup1.Caption:=ReadString(section,'t_4',deftxt);
    RadioGroup1.items[0]:=ReadString(section,'t_5',deftxt);
    RadioGroup1.items[1]:=ReadString(section,'t_6',deftxt);
    RadioGroup2.Caption:=ReadString(section,'t_7',deftxt);
    RadioGroup2.items[0]:='0='+ReadString(section,'t_8',deftxt);
    RadioGroup2.items[1]:='0='+ReadString(section,'t_9',deftxt);
    BitBtn1.Caption:=ReadString('buttons','ok',deftxt);
    BitBtn2.Caption:=ReadString('buttons','cancel',deftxt);
    BitBtn3.Caption:=ReadString('buttons','help',deftxt);
    edit1.text:='0'+ldeg+' - 19'+ldeg;
    edit2.text:='20'+ldeg+' - 49'+ldeg;
    edit3.text:='50'+ldeg+' - 89'+ldeg;
    edit4.text:='90'+ldeg+' - 179'+ldeg;
    edit5.text:='180'+ldeg+' - 270'+ldeg;
    edit6.text:='271'+ldeg+'-  360'+ldeg;
  end;
inifile.free;
end;
end;


procedure TProjForm.FormCreate(Sender: TObject);
begin
setlang;
end;

procedure TProjForm.BitBtn3Click(Sender: TObject);
begin
showhelp('doc3.html#proj');
end;

end.
