unit RechercheUnit;

interface

uses Skylib,SelCatUnit,IniFiles,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls, CheckLst;

Procedure SetLang;

type
  TRecherche = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    catalogue1: TRadioGroup;
    TabSheet2: TTabSheet;
    catalogue2: TRadioGroup;
    TabSheet3: TTabSheet;
    catalogue3: TRadioGroup;
    TabSheet4: TTabSheet;
    catalogue4: TRadioGroup;
    Panel1: TPanel;
    Edit1: TEdit;
    Panel2: TPanel;
    Label6: TLabel;
    constelation: TComboBox;
    Label1: TLabel;
    Panel3: TPanel;
    starsname: TComboBox;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Label3: TLabel;
    PlaneteBox: TComboBox;
    Label2: TLabel;
    CometeBox: TComboBox;
    Label4: TLabel;
    AsteroidBox: TComboBox;
    TabSheet5: TTabSheet;
    CheckListBox1: TCheckListBox;
    Panel7: TPanel;
    Button1: TButton;
    Panel8: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    Panel9: TPanel;
    ObjectName: TComboBox;
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CometeBoxChange(Sender: TObject);
    procedure CatalogueClick(Sender: TObject);
    procedure PlanetBoxChange(Sender: TObject);
    procedure AsteroidBoxChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure starsnameChange(Sender: TObject);
    procedure constelationChange(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton11Click(Sender: TObject);
    procedure SpeedButton13Click(Sender: TObject);
    procedure ObjectNameChange(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Recherche: TRecherche;

var
   catalog : Integer;
   num : string;
   starlst : array of integer;
   maxstar, numcon, numobjectname : integer;
   constelAR : array of single;
   constelDE : array of single;
   objectnameAR : array of single;
   objectnameDE : array of single;

implementation

uses sky_p1;

var    appmsg : array [1..5] of string;
       customcatnum : integer;

const
cat : array [0..4,0..10] of integer =(
            (0,1,2,3,21,22,23,24,28,0,0),
            (4,25,5,6,7,8,9,10,11,12,27),
            (26,0,0,0,0,0,0,0,0,0,0),
            (16,17,18,19,20,0,0,0,0,0,0),
            (14,13,15,0,0,0,0,0,0,0,0));

{$R *.DFM}

procedure InitString;
begin
appmsg[1]:='Entrer une valeur numrique !';
appmsg[2]:='You must be connected to the Internet to use this option'
end;

procedure TRecherche.BitBtn2Click(Sender: TObject);
begin
ModalResult := mrCancel;
end;

procedure TRecherche.BitBtn1Click(Sender: TObject);
begin
case PageControl1.ActivePageIndex of
0 : catalog := cat[0,Catalogue1.itemindex];
1 : catalog := cat[1,Catalogue2.itemindex];
2 : catalog := cat[2,0];
3 : catalog := cat[3,Catalogue3.itemindex];
4 : catalog := cat[4,Catalogue4.itemindex];
end;
inc(catalog);
if trim(num)='' then ShowMessage(appmsg[1])
                else ModalResult := mrOk;
end;

Procedure Showpanel(var panel : Tpanel);
begin
recherche.panel1.visible:=false;
recherche.panel2.visible:=false;
recherche.panel3.visible:=false;
recherche.panel4.visible:=false;
recherche.panel5.visible:=false;
recherche.panel6.visible:=false;
recherche.panel9.visible:=false;
panel.visible:=true;
end;

Procedure InitCustom;
var i,j : integer;
begin
customcatnum:=CatalogNum;
recherche.checklistbox1.Clear;
for i:=0 to CatalogNum-1 do begin
  j:=recherche.checklistbox1.Items.add(CatalogList[i].shortname+' '+CatalogList[i].name);
  recherche.checklistbox1.checked[j]:=CatalogList[i].Actif and (fileexists(CatalogList[i].path+CatalogList[i].shortname+'.idx'));
end;
end;

Procedure SetPanel;
begin
with Recherche do begin
case PageControl1.ActivePageIndex of
0 : case Catalogue1.itemindex of
    8 : Showpanel(panel9);
    else Showpanel(panel1);
    end;
1 : Showpanel(panel1);
2 : Showpanel(panel1);
3 : case Catalogue3.itemindex of
    0 : Showpanel(panel2);
    1 : Showpanel(panel3);
    else Showpanel(panel1);
    end;
4 : case Catalogue4.itemindex of
    0 : Showpanel(panel4);
    1 : Showpanel(panel5);
    2 : Showpanel(panel6);
    end;
end;
if panel1.visible then begin edit1.selectall;edit1.SetFocus;num:=edit1.text;end;
if panel5.visible then begin CometeBox.SetFocus;num:=inttostr(CometeBox.ItemIndex+1);end;
if panel4.visible then begin PlaneteBox.SetFocus;num:=inttostr(PlaneteBox.ItemIndex+1);end;
if panel6.visible then begin AsteroidBox.SetFocus;num:=inttostr(AsteroidBox.ItemIndex+1);end;
if panel2.visible then begin constelation.SetFocus;num:=inttostr(constelation.ItemIndex+1);end;
if panel3.visible then begin starsname.SetFocus;num:=inttostr(starlst[starsname.ItemIndex]);end;
end;
end;

procedure TRecherche.FormShow(Sender: TObject);
var i :Integer;
begin
CometeBox.Items.Clear;
PlaneteBox.Items.Clear;
AsteroidBox.Items.Clear;
for i:=1 to CometNb do CometeBox.Items.Add(CometNLst[i]);
if planetshow then for i:=1 to 11 do PlaneteBox.Items.Add(Pla[i]);
for i:=1 to AsteroidNb do AsteroidBox.Items.Add(AsteroidNLst[i]);
CometeBox.ItemIndex:=0;
PlaneteBox.ItemIndex:=0;
AsteroidBox.ItemIndex:=0;
if customcatnum<>CatalogNum then initcustom;
SetPanel;
if panel1.visible then begin edit1.selectall;edit1.SetFocus;end;
if panel5.visible then begin CometeBox.itemindex:=strtointdef(num,1)-1;CometeBox.SetFocus;end;
if panel4.visible then begin PlaneteBox.itemindex:=strtointdef(num,1)-1;PlaneteBox.SetFocus;end;
if panel6.visible then begin AsteroidBox.itemindex:=strtointdef(num,1)-1;AsteroidBox.SetFocus;end;
if panel2.visible then constelation.SetFocus;
if panel3.visible then starsname.SetFocus;
end;

procedure TRecherche.AsteroidBoxChange(Sender: TObject);
begin
num:=inttostr(AsteroidBox.ItemIndex+1);
end;

procedure TRecherche.CometeBoxChange(Sender: TObject);
begin
num:=inttostr(CometeBox.ItemIndex+1);
end;

procedure TRecherche.PlanetBoxChange(Sender: TObject);
begin
if PlaneteBox.ItemIndex+1 = 3 then num:='11'
   else num:=inttostr(PlaneteBox.ItemIndex+1);
end;

procedure TRecherche.CatalogueClick(Sender: TObject);
begin
Setpanel;
if not NetWorkOn then begin
 if (Pagecontrol1.ActivePageIndex=0)and(Catalogue1.itemindex>=6)and(Catalogue1.itemindex<8) then begin
   ShowMessage(appmsg[2]);
   Catalogue1.itemindex:=0;
 end;
end;
end;

procedure InitStarName;
var
    buf,n,fn : string;
    f : TextFile;
    i : integer;
begin
if debugon then writedebug('Read Stars Name file');
try
recherche.starsname.Clear;
i:=0;
maxstar:=0;
fn:=bscpath+'\starsname_'+language+'.dat';
if not fileexists(fn) then fn:=bscpath+'\starsname.dat';
if FileExists(fn) then begin
  maxstar:=100;
  setlength(starlst,maxstar);
  if debugon then writedebug('Assignfile '+fn);
  AssignFile(f,fn);
  FileMode:=0;
  if debugon then writedebug('Reset file '+fn);
  reset(f);
  repeat
    if i>=maxstar then begin
       maxstar:=maxstar+100;
       setlength(starlst,maxstar)
    end;
    Readln(f,buf);
    if copy(buf,1,1)=';' then continue;
    n:=trim(copy(buf,1,6));
    buf:=trim(copy(buf,10,999));
    recherche.starsname.items.Add(buf);
    starlst[i]:=strtointdef(n,0);
    inc(i);
  until eof(f);
  if debugon then writedebug('Close file '+fn);
  CloseFile(f);
end;
finally
maxstar:=recherche.starsname.items.Count;
if recherche.starsname.items.Count=0 then begin
  if debugon then writedebug('Empty Stars Name list');
  recherche.starsname.items.add(' ');
end;
//recherche.starsname.Text:=recherche.starsname.Items[0];
recherche.starsname.itemindex:=0;
end;
end;

procedure InitConstel;
var
    n,fn : string;
    buf : string;
    f : textfile;
    i,p : integer;
begin
if debugon then writedebug('Read Constelation file');
try
recherche.constelation.Clear;
i:=1;
fn:=bscpath+'\constlabel_'+language+'.dat';
if not fileexists(fn) then fn:=bscpath+'\constlabel.dat';
numcon:=90;
setlength(constelAR,numcon);
setlength(constelDE,numcon);
if FileExists(fn) then begin
  if debugon then writedebug('Assignfile '+fn);
  AssignFile(f,fn);
  FileMode:=0;
  if debugon then writedebug('Reset file '+fn);
  reset(f);
  repeat
    if i>=numcon then begin
       numcon:=numcon+50;
       setlength(constelAR,numcon);
       setlength(constelDE,numcon);
    end;
    Readln(f,buf);
    p:=pos(';',buf);
    if p=0 then continue;
    if not isnumber(trim(copy(buf,1,p-1))) then continue;
    constelAR[i]:=15*strtofloat(trim(copy(buf,1,p-1)));
    delete(buf,1,p);
    p:=pos(';',buf);
    if p=0 then continue;
    constelDE[i]:=strtofloat(trim(copy(buf,1,p-1)));
    delete(buf,1,p);
    p:=pos(';',buf);
    if p=0 then continue;
    n:=trim(copy(buf,1,p-1));
    delete(buf,1,p);
    n:=n+' , '+trim(buf);
    recherche.constelation.items.Add(n);
    inc(i);
  until eof(f);
  numcon:=i-1;
  if debugon then writedebug('Close file '+fn);
  CloseFile(f);
end;
finally
if recherche.constelation.items.Count=0 then begin
  if debugon then writedebug('Empty Constelation list');
  recherche.constelation.items.add(' ');
end;
recherche.constelation.ItemIndex:=0;
end;
end;

procedure InitObjectName;
var
    n,fn : string;
    buf : string;
    f : textfile;
    i,p : integer;
begin
if debugon then writedebug('Read Object name file');
try
recherche.ObjectName.Clear;
i:=1;
fn:=sacpath+'\ObjectNamesList_'+language+'.dat';
if not fileexists(fn) then fn:=sacpath+'\ObjectNamesList.dat';
numObjectName:=100;
setlength(ObjectNameAR,numObjectName);
setlength(ObjectNameDE,numObjectName);
if FileExists(fn) then begin
  if debugon then writedebug('Assignfile '+fn);
  AssignFile(f,fn);
  FileMode:=0;
  if debugon then writedebug('Reset file '+fn);
  reset(f);
  repeat
    if i>=numObjectName then begin
       numObjectName:=numObjectName+50;
       setlength(ObjectNameAR,numObjectName);
       setlength(ObjectNameDE,numObjectName);
    end;
    Readln(f,buf);
    p:=pos(';',buf);
    if p=0 then continue;
    if not isnumber(trim(copy(buf,1,p-1))) then continue;
    ObjectNameAR[i]:=strtofloat(trim(copy(buf,1,p-1)));
    delete(buf,1,p);
    p:=pos(';',buf);
    if p=0 then continue;
    ObjectNameDE[i]:=strtofloat(trim(copy(buf,1,p-1)));
    delete(buf,1,p);
    n:=trim(buf);
    recherche.ObjectName.items.Add(n);
    inc(i);
  until eof(f);
  numObjectName:=i-1;
  if debugon then writedebug('Close file '+fn);
  CloseFile(f);
end;
finally
if recherche.ObjectName.items.Count=0 then begin
  if debugon then writedebug('Empty Object Name list');
  recherche.ObjectName.items.add(' ');
end;
recherche.ObjectName.ItemIndex:=0;
end;
end;

procedure TRecherche.FormCreate(Sender: TObject);
begin
num:='';
InitString;
SetLang;
InitStarName;
InitConstel;
InitCustom;
InitObjectName;
end;

procedure TRecherche.starsnameChange(Sender: TObject);
begin
if starsname.ItemIndex>=0 then num:=inttostr(starlst[starsname.ItemIndex])
                          else num:='0';
end;

procedure TRecherche.constelationChange(Sender: TObject);
begin
num:=inttostr(constelation.ItemIndex+1);
end;

procedure TRecherche.BitBtn3Click(Sender: TObject);
begin
showhelp('doc1.html#recherche');
end;


procedure TRecherche.Edit1Change(Sender: TObject);
begin
num:=edit1.text;
end;

procedure TRecherche.Button1Click(Sender: TObject);
begin
initcustom;
end;

procedure TRecherche.SpeedButton1Click(Sender: TObject);
begin
with sender as TspeedButton do begin
  edit1.text:=edit1.text+caption;
end;
end;

procedure TRecherche.SpeedButton11Click(Sender: TObject);
var buf : string;
begin
buf:=edit1.text;
delete(buf,length(buf),1);
edit1.text:=buf;
end;

procedure TRecherche.SpeedButton13Click(Sender: TObject);
begin
edit1.text:='';
end;

procedure TRecherche.ObjectNameChange(Sender: TObject);
begin
num:=inttostr(ObjectName.ItemIndex+1);
end;

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
    i : integer;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='find';
with Recherche do
  with inifile do begin
    Label1.Caption:=ReadString(section,'t_1',deftxt);
    Label2.Caption:=ReadString(section,'t_2',deftxt);
    Label3.Caption:=ReadString(section,'t_3',deftxt);
    Label4.Caption:=ReadString(section,'t_4',deftxt);
//    Label5.Caption:=ReadString(section,'t_6',deftxt);
    Caption:=ReadString(section,'t_5',deftxt);
    Label6.Caption:=ReadString(section,'t_7',deftxt);
    Catalogue4.Items[1]:=ReadString(section,'t_2',deftxt);
    Catalogue4.Items[0]:=ReadString(section,'t_3',deftxt);
    Catalogue4.Items[2]:=ReadString(section,'t_4',deftxt);
    Catalogue3.Items[0]:=ReadString(section,'t_7',deftxt);
    Catalogue3.Items[1]:=ReadString(section,'t_6',deftxt);
    Catalogue3.Items[2]:=ReadString(section,'t_8',deftxt);
    Catalogue3.Items[3]:=ReadString(section,'t_9',deftxt);
    Catalogue3.Items[4]:=ReadString(section,'t_10',deftxt);
    Catalogue1.Items[4]:=ReadString(section,'t_11',deftxt);
    TabSheet1.caption:=ReadString(section,'t_12',deftxt);
    TabSheet2.caption:=ReadString(section,'t_13',deftxt);
    TabSheet3.caption:=ReadString(section,'t_14',deftxt);
    TabSheet4.caption:=ReadString(section,'t_15',deftxt);
    TabSheet5.caption:=ReadString(section,'t_16',deftxt);
    Button1.caption:=ReadString(section,'t_17',deftxt);
    Catalogue1.Items[5]:=ReadString(section,'t_18',deftxt);
    Catalogue1.Items[6]:=ReadString(section,'t_19',deftxt);
    Catalogue1.Items[7]:=ReadString(section,'t_20',deftxt);
    Catalogue1.Items[8]:=ReadString(section,'t_21','Nebula common name');
    BitBtn1.Caption:=ReadString('buttons','ok',deftxt);
    BitBtn2.Caption:=ReadString('buttons','cancel',deftxt);
    BitBtn3.Caption:=ReadString('buttons','help',deftxt);
    for i:=1 to 5 do begin
       appmsg[i]:=ReadString(section,'m_'+trim(inttostr(i)),deftxt);
    end;
  end;
inifile.free;
end;
InitStarName;
InitConstel;
InitObjectName;
end;

end.
