unit Sky_zoom;

interface

uses
  SkyLib,Math,Inifiles,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, Mask;

Procedure SetLang;

type
  TZoom1 = class(TForm)
    TrackBar1: TTrackBar;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Edit1: TEdit;
    BitBtn3: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Zoom1: TZoom1;

implementation

{$R *.DFM}
var larg,logla : double;

Procedure SetLang;
var inifile : Tmeminifile;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
with Zoom1 do
  with inifile do begin
    BitBtn1.Caption:=ReadString('buttons','ok',deftxt);
    BitBtn2.Caption:=ReadString('buttons','cancel',deftxt);
    BitBtn3.Caption:=ReadString('buttons','help',deftxt);
  end;
inifile.free;
end;
end;

procedure TZoom1.BitBtn2Click(Sender: TObject);
begin
   ModalResult := mrCancel;
end;

procedure TZoom1.BitBtn1Click(Sender: TObject);
begin
   SkyLib.Largeur := larg;
   ModalResult := mrOK;
end;

procedure TZoom1.TrackBar1Change(Sender: TObject);
begin
logla:=TrackBar1.Position;
larg:=power(10,logla/100);
larg:=minvalue([360,larg]);
if larg>3 then larg:=round(larg);
Edit1.text:=DeMtoStr(larg);
end;

procedure TZoom1.FormShow(Sender: TObject);
begin
larg:=SkyLib.Largeur;
logla:=100*log10(larg);
TrackBar1.Position := Round(logla);
Edit1.text:=DeMtoStr(larg);
TrackBar1.SetTick(0);
TrackBar1.SetTick(100);
TrackBar1.SetTick(200);
end;

procedure TZoom1.FormCreate(Sender: TObject);
begin
SetLang;
end;

procedure TZoom1.BitBtn3Click(Sender: TObject);
begin
showhelp('doc1.html#echelle');
end;

end.
