unit UserLabel;

interface

uses Skylib,Inifiles,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TUserLabelForm = class(TForm)
    RadioGroup1: TRadioGroup;
    Button1: TButton;
    Edit1: TEdit;
    ColorDialog1: TColorDialog;
    GroupBox1: TGroupBox;
    Shape1: TShape;
    GroupBox2: TGroupBox;
    s1: TEdit;
    sz1: TUpDown;
    Label1: TLabel;
    Button2: TButton;
    procedure Shape1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  UserLabelForm: TUserLabelForm;

Procedure SetLang;

implementation

{$R *.dfm}

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='label';
with UserLabelForm do
  with inifile do begin
    Caption:=ReadString(section,'t_22',caption);
    Radiogroup1.Caption:=ReadString(section,'t_4',Radiogroup1.Caption);
    Radiogroup1.items[0]:=ReadString(section,'t_5',Radiogroup1.items[0]);
    Radiogroup1.items[1]:=ReadString(section,'t_6',Radiogroup1.items[1]);
    Radiogroup1.items[2]:=ReadString(section,'t_23',Radiogroup1.items[2]);
    GroupBox1.Caption:=ReadString(section,'t_24',GroupBox1.Caption);
    GroupBox2.Caption:=ReadString(section,'t_25',GroupBox2.Caption);
    Label1.Caption:=ReadString(section,'t_26',Label1.Caption);
    Button1.Caption:=ReadString('buttons','ok',deftxt);
    Button2.Caption:=ReadString('buttons','cancel',deftxt);
  end;
inifile.free;
end;
end;

procedure TUserLabelForm.Shape1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
if ColorDialog1.Execute then Shape1.Brush.Color:=ColorDialog1.Color;
end;

procedure TUserLabelForm.FormCreate(Sender: TObject);
begin
setlang;
end;

end.
