unit blinkunit;

interface

uses IniFiles,Skylib,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

Procedure SetLang;
  
type
  TBlink = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Blink: TBlink;
  blinktime : integer;

implementation

{$R *.DFM}

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='blink';
with Blink do
  with inifile do begin
    Label1.Caption:=ReadString(section,'t_1',deftxt);
    Label2.Caption:=ReadString(section,'t_2',deftxt);
    BitBtn1.Caption:=ReadString('buttons','ok',deftxt);
  end;
inifile.free;
end;
end;

procedure TBlink.FormShow(Sender: TObject);
begin
Edit1.Text:=inttostr(blinktime);
end;

procedure TBlink.BitBtn1Click(Sender: TObject);
begin
BlinkTime:=strtointdef(edit1.text,1000);
modalresult:=mrOk;
end;

procedure TBlink.FormCreate(Sender: TObject);
begin
SetLang;
end;

end.
